import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.Dimension;
import java.awt.Component;

import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JLabel;



public class PrincipalWindow extends JFrame {

	/**
	 * @param args
	 */
	private static final long serialVersionUID = 1L;
	
	private EntryWindow setup;
	private JButton button;
	private JPasswordField pwdfield;
	private Cliente cliente;
	private int count = 3;
	private JMenuItem fileClose;
	private JMenuItem fileConnect;
	private JLabel display;
	
	public PrincipalWindow(){
		
		setTitle("Proyecto elo330");
		setup = new EntryWindow();
		
		setUI();
		
		setAL();
		
		setExtendedState(MAXIMIZED_BOTH);
        setLocationRelativeTo(null);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setVisible(true);

	}
	
	private void setUI(){
		JMenuBar menubar = new JMenuBar();
        ImageIcon icon = new ImageIcon("./exit2.gif");
        ImageIcon icon2 = new ImageIcon("./connect.png");

        JMenu file = new JMenu("File");
        file.setMnemonic(KeyEvent.VK_F);

        fileClose = new JMenuItem("Close", icon);
        fileClose.setMnemonic(KeyEvent.VK_Q);
        fileClose.setToolTipText("Exit application");
        
        fileConnect = new JMenuItem("Connect", icon2);
        fileConnect.setMnemonic(KeyEvent.VK_C);
        fileConnect.setToolTipText("Connect to Server");
        
        file.add(fileConnect);
        
        file.add(fileClose);

        menubar.add(file);

        setJMenuBar(menubar);
        
        button = new JButton("Log in");
        button.setEnabled(false);
        button.setAlignmentY(Component.TOP_ALIGNMENT);
        
        pwdfield = new JPasswordField();
        pwdfield.setEnabled(false);
        pwdfield.setMaximumSize(new Dimension(300,25));
        pwdfield.setAlignmentY(Component.TOP_ALIGNMENT);
        
        display = new JLabel();
        display.setPreferredSize(new Dimension(400, 600));
        display.setMaximumSize(new Dimension(400, 600));
        display.setAlignmentX(Component.CENTER_ALIGNMENT);
        display.setIcon(new ImageIcon("./doorclosed.jpg"));
        
        JPanel first = new JPanel();
        first.setLayout(new BoxLayout(first, BoxLayout.X_AXIS));
        add(first);
        
        first.add(pwdfield);
        first.add(button);
        first.add(display);

	}
	
	private void setAL(){
		
		fileClose.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event) {
                System.exit(0);
            }

        });
		
		fileConnect.addActionListener(new ActionListener(){
        	public void actionPerformed(ActionEvent event) {
                setup.setVisible(true);
                button.setEnabled(true);
                pwdfield.setEnabled(true);
                display.setIcon(new ImageIcon("./doorclosed.jpg"));
            }
        });
		
		setup.ok.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				
				String ipconnect = setup.field1.getText();
				String portconnect = setup.field2.getText();
				setup.setVisible(false);
				cliente = new Cliente(ipconnect, portconnect, button, pwdfield);
				cliente.conectar();
				count = 3;
			}
		});
		
		button.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				
				System.out.println("en la ventana principal: " + new String(pwdfield.getPassword()));
					
				if (cliente.verificarPassword(new String(pwdfield.getPassword()), count))
					display.setIcon(new ImageIcon("./dooropened.jpg"));
				else{
					count--;
					display.setIcon(new ImageIcon("./doorclosed.jpg"));
				}
				
				
				pwdfield.setText(null);
			}
		});
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		new PrincipalWindow();
	}

}
